#line 1234 "mcdep.nw"
#include "tools.h"
#include <cctype>
#include <algorithm>
#line 845 "mcdep.nw"
const char*  skipWhiteSpaces(const char* line)
{
   for (; isspace(*line); ++line);
   return line;
}
#line 1249 "mcdep.nw"
string   cutTail
(
   const string&  s, 
   char           delim, 
   const string&  defaultVal
)
{
   const char*  cs = s.c_str();
   const char*  csEnd = cs + s.size();
   reverse_iterator<const char*>  rb(csEnd), re(cs), 
                                  where = find(rb, re, delim);
   string       r = (where != re 
                    ? string(cs, s.size() - (where - rb) - 1)
                    : defaultVal);
   return r;
}
#line 1274 "mcdep.nw"
string uptoSuffix(const string& s)
{
   return cutTail(s, '.', s);
}
#line 1288 "mcdep.nw"
string uptoDir(const string& s)
{
   static const string  empty("");
   return cutTail(s, '/', empty);
}
#line 1302 "mcdep.nw"
string  prependDir(const string& dir, const string& fileTail)
{
   static const string  slash("/");
   string fileName = (dir.empty() ? fileTail : dir + slash + fileTail);
   return fileName;
} 
