#line 1141 "xc.nw"
#include "XCGraph.h"
#line 1147 "xc.nw"
typedef XCTGraph<char>  XCSGraph;
#line 1193 "xc.nw"
bool  readEdges(istream& istr, XCSGraph& g, std::set<std::string>& repo)
{
   while (!istr.fail() && !istr.eof())
   {
      std::string  sFrom, sTo;
      istr >> sFrom >> sTo;
      if (!istr.eof())
      {
         pair<std::set<std::string>::iterator, bool> insertion;
         insertion = repo.insert(sFrom);
         const char*  cFrom = (*insertion.first).c_str();
         insertion = repo.insert(sTo);
         const char*  cTo = (*insertion.first).c_str();
         g.addEdge(cFrom, cTo);
      }
   }
   return true;
}
#line 1220 "xc.nw"
void printEdges(ostream& os, XCSGraph& g, std::set<std::string>& repo)
{
   enum {adj, xadj, nModes};
   for (int loop = adj; loop != nModes;  ++loop)
   {
      os << (loop == adj ? "Adjacents:" : "Transitive-Adjacents") << endl;
      for (std::set<std::string>::const_iterator  
              i = repo.begin(), e = repo.end();  i != e;  ++i)
      {
         const char*  cNode = (*i).c_str();
         os << "   " << cNode << ":";
         const XCSGraph::TIter  iNode = g.node(cNode);
         const XCSGraph::TIter  gvEnd = g.vEnd();
         // if (pNode == g.vEnd())
         if (iNode == gvEnd)
         {
            os << " disappeared! - ERROR" << endl;
         }
         else
         {  
            os << endl;
            
#line 1250 "xc.nw"
const XCSGraph::TNode  nd = *iNode;
for (XCSGraph::TIter
        i = ((loop == adj) ? nd.adjacentsBegin() : nd.xAdjacentsBegin()),
        e = ((loop == adj) ? nd.adjacentsEnd()   : nd.xAdjacentsEnd());
     i != e;  ++i)
{
   const char*  cs = i.ptr();
   os << "      " << cs << endl;
}
#line 1242 "xc.nw"
         }
      }
   }
}
#line 1152 "xc.nw"
int main(int, char**)
{
   bool ok = true;
   std::set<std::string>  strRepo;
   XCSGraph  gb;
   ok = readEdges(cin, gb, strRepo);
   XCSGraph  gbDFS(gb);
   ok = (gb == gbDFS);
   if (ok)
   {
      gb.FloydWarshall_xClosure();
      // Now not equal
      ok = ok && ((gb.nV() == 0) || (gb != gbDFS));
      if (ok)
      {
         gbDFS.DFS_xClosure();
         printEdges(cout << "DFS_xClosure:" << endl, gbDFS, strRepo);
         ok = ok && (gb == gbDFS);
         if (!ok)
         {
            printEdges(cout << "!=  Floyd-Warshall:" << endl, gb, strRepo);
         }
         else 
         {
            gb = gbDFS;
            ok = ok && (gb == gbDFS);
         }
      }
   }
   return !ok;
}
